/**
 *  @author Eric Augustine
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>

#include "cast.h"
#include "data.h"

void print_image(double min_x, double max_x,
                 double min_y, double max_y,
                 int width, int height,
                 struct point eye,
                 struct sphere spheres[], int num_spheres,
                 struct color amb_light) {
   printf("P3\n");
   printf("%d %d\n", width, height);
   printf("255\n");
   cast_all_rays(min_x, max_x,
                 min_y, max_y,
                 width, height,
                 eye,
                 spheres, num_spheres,
                 amb_light);
}

int main(int argc, char *argv[]) {
   double min_x = -10;
   double max_x = 10;

   double min_y = -7.5;
   double max_y = 7.5;

   int width = 1024;
   int height = 768;

   struct color amb_light = create_color(1, 1, 1);

   struct point eye = create_point(0, 0, -14);

   struct sphere spheres[] = {
      create_sphere(create_point(1, 1, 0),
                    2,
                    create_color(0, 0, 1),
                    create_finish(0.2)),
      create_sphere(create_point(0.5, 1.5, -3),
                    0.5,
                    create_color(1, 0, 0),
                    create_finish(0.4))
   };

   print_image(min_x, max_x,
               min_y, max_y,
               width, height,
               eye,
               spheres, 2,
               amb_light);

   return EXIT_SUCCESS;
}
